﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        UltraWebGrid1.DisplayLayout.ViewType = Infragistics.WebUI.UltraWebGrid.ViewType.Hierarchical;
        UltraWebGrid1.DataSource = populateDataSet();
        UltraWebGrid1.DataBind();
        UltraWebGrid1.ExpandAll();
    }

    private DataSet populateDataSet()
    {

        DataSet ds = new DataSet();
        DataTable Parent = new DataTable();
        Parent.TableName = "Parent";
        DataTable Child = new DataTable();
        Child.TableName = "Child";

        Parent.Columns.Add("ID");
        Parent.Columns.Add("Name");

        DataColumn[] col = new DataColumn[1];
        col[0] = Parent.Columns["ID"];
        Parent.PrimaryKey = col;

        DataRow row = Parent.NewRow();

        Child.Columns.Add("ID");
        Child.Columns.Add("Address");
        Child.Columns.Add("Count", typeof(int));
        
        for(int i=0 ; i < 50; i++) {


            row = Parent.NewRow();
            row.SetField<int>("ID", i);
            row.SetField<String>("Name", "Bob");
            Parent.Rows.Add(row);



            row = Child.NewRow();
            row.SetField<int>("ID", i);
            row.SetField<string>("Address", "Paris");
            row.SetField<int>("Count", 5);
            Child.Rows.Add(row);

            row = Child.NewRow();
            row.SetField<int>("ID", i);
            row.SetField<string>("Address", "Rome");
            row.SetField<int>("Count", 9);
            Child.Rows.Add(row);

            row = Child.NewRow();
            row.SetField<int>("ID", i);
            row.SetField<string>("Address", "London");
            row.SetField<int>("Count", 2);
            Child.Rows.Add(row);

            row = Child.NewRow();
            row.SetField<int>("ID", i);
            row.SetField<string>("Address", "LosAngeles");
            row.SetField<int>("Count", 9);
            Child.Rows.Add(row);
        }
        ds.Tables.Add(Parent);
        ds.Tables.Add(Child);


        DataRelation relation = new DataRelation("IDRelation", Parent.Columns["ID"], Child.Columns["ID"]);
        ds.Relations.Add(relation);


        // Add the column in the parent DataTable which Sums the values from the children based on the id relation
        Parent.Columns.Add("Sum", typeof(int), "Sum(Child(IDRelation).Count)");

        return ds;
    }
}